# Re-using Code

Developers re-use existing code all the time. Here are some examples:
- Any time we install packages with a package manager.
- When we are collaborating on a team, we are building on the work of our teammates.
- When we read documentation or a code repository, and copy/paste blocks of code.
- When we ask an AI chatbot to help us write some code.

<br />
---

## When you re-use code:
1. **Make sure you know how to use it.** Of course you can copy and paste any time. Even if you would not be able to write it, try to understand how the code works. This is always true - and perhaps even more important when you are re-using smart contract code.
2. **Check the license.** Make sure you're allowed to use the code.
3. **Try to contribute.** If you like [Aiken](https://aiken-lang.org/) or [plu-ts](https://pluts.harmoniclabs.tech/), [Mesh](https://meshjs.dev/) or [Lucid](https://github.com/spacebudz/lucid), [TxPipe](https://txpipe.io/) or this Plutus PBL course, all of these builders are accessible. Go say thanks. Go ask what you can do to help. Write a bit of documentation.

<br />
---

## When you install a package, you are re-using code.
- [Cargo](https://doc.rust-lang.org/cargo/), [Cabal](https://www.haskell.org/cabal/), [Nix](https://nixos.org/manual/nix/stable/package-management/package-management.html),  [npm](https://www.npmjs.com/), and [Yarn](https://yarnpkg.com/) are all package managers.
- When you install a package using any of these tools, you are re-using code.

### For Example
In the PPBL2023 Plutus Template, in the file [ppbl2023-plutus-template.cabal](https://gitlab.com/gimbalabs/ppbl-2023/ppbl2023-plutus-template/-/blob/main/ppbl2023-plutus-template.cabal), there is a list of `build-depends` that looks like this:
```cabal
  build-depends:      base ^>=4.14.3.0
                    , aeson
                    , bytestring
                    , containers
                    , cardano-api
                    , data-default
                    , plutus-ledger-api
                    , plutus-tx-plugin
                    , plutus-tx
                    , text
                    , serialise
                    , plutus-core
                    , tagged
                    , prettyprinter
                    , cardano-api
```

Each of these build dependencies is a package that was written by other developers.

In Module 201, we will build a simple front-end for interacting with Cardano. We will start by installing a set of packages that will be used to an application.

<br />
---

## Test Yourself with AI Code Generation
Here's a cool test that you can run any time.

### Step by Step:
1. Ask Chat GPT or GitHub Copilot how to write some code.
2. Can you tell if the response is correct or not?

#### What does this test tell you about your mastery of SLT 103.2?

import MDXLessonLayout from "@/src/components/lms/Lesson/MDXLessonLayout.tsx";
export default ({ children }) => <MDXLessonLayout>{children}</MDXLessonLayout>;